/***********************************************************

Copyright Derrick Stolee 2011.

 This file is part of SearchLib.

    SearchLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SearchLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SearchLib.  If not, see <http://www.gnu.org/licenses/>.

*************************************************************/

/*
 * SaturationDataSymmetry.hpp
 *
 *  Created on: Apr 18, 2011
 *      Author: stolee
 */

#ifndef SATURATIONDATASYMMETRY_HPP_
#define SATURATIONDATASYMMETRY_HPP_

#include "GraphData.hpp"
#include "SaturationNode.hpp"
#include "nausparse.h"
#include "gtools.h"

/**
 * Given a graph, fill in the unassigned orbits for
 */
void computeUnassignedOrbits(GraphData* satdata, SaturationNode* node);

/**
 * Given a graph and an unassigned edge, compute all completion orbits
 * 	for that edge.
 *
 * BONUS: the completion orbits may be filtered by removing completion sets
 * 	where there is a 0-edge which would need to be a 1-edge.
 */
void computeStabilizedOrbits(int r, GraphData* satdata, int pairindex, SaturationNode* augment);

#endif /* SATURATIONDATASYMMETRY_HPP_ */
