/***********************************************************

Copyright Derrick Stolee 2011.

 This file is part of SearchLib.

    SearchLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SearchLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SearchLib.  If not, see <http://www.gnu.org/licenses/>.

*************************************************************/

/*
 * SaturationNode.cpp
 *
 *  Created on: Aug 24, 2011
 *      Author: dstolee
 */

#include "SearchManager.hpp"
#include "SaturationNode.hpp"
#include <stdlib.h>

SaturationNode::SaturationNode(LONG_T label) :
		SearchNode(label)
{
	this->curChild = -1;
	this->initialized = false;
	this->numOrbits = -1;
	this->curOrbit = -1;
	this->orbitReps = 0;
	this->orbitSets = 0;
	this->orbitSizes = 0;
	this->curNumCompleters = -1;
	this->curOrbitCompleterReps = 0;
	this->chosenOrbit = -1;
}

SaturationNode::~SaturationNode()
{
	if ( this->orbitReps != 0 )
	{
		free(this->orbitReps);
		this->orbitReps = 0;
	}

	if ( this->orbitSets != 0 )
	{
		for ( int i = 0; i < this->numOrbits; i++ )
		{
			if ( this->orbitSets[i] != 0 )
			{
				free(this->orbitSets[i]);
				this->orbitSets[i] = 0;
			}
		}

		free(this->orbitSets);
		this->orbitSets = 0;
	}

	if ( this->orbitSizes != 0 )
	{
		free(this->orbitSizes);
		this->orbitSizes = 0;
	}

	if ( this->curOrbitCompleterReps != 0 )
	{
		free(this->curOrbitCompleterReps);
		this->curOrbitCompleterReps = 0;
	}
}
