/*
 * testsaturationdata.cpp
 *
 *  Created on: Aug 29, 2011
 *      Author: dstolee
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gtools.h"

#include "SaturationData.hpp"
#include "translation.hpp"
#include "SaturationDataSymmetry.hpp"
#include "SaturationNode.hpp"

int main(int argc, char** argv)
{
	if ( argc < 3 )
	{
		printf("Usage: testsaturationdata.exe N r\n");
		return 1;
	}

	int N = atoi(argv[1]);
	int r = atoi(argv[2]);

	SaturationData* data = new SaturationData(r, N);
	SaturationNode* node = new SaturationNode(0);

	printf("%s", data->getOneGraphString());
	printf("%s", sgtos6(data->getLayeredGraph()));

	data->augmentCompletion(indexOf(r - 2, r - 1), 0);

	printf("%s", data->getOneGraphString());
	printf("%s", sgtos6(data->getLayeredGraph()));

	bool working = true;
	int i = r;
	while ( working && r < N && data->isUniquelyKrSaturated() == false && data->getNum2Edges() > 0 )
	{
		computeUnassignedOrbits(data, node);
		computeStabilizedOrbits(r, data, node->orbitReps[0], node);

		int vi,vj;

		printf("\t%d orbits\n", node->numOrbits);
		for ( int i = 0; i < node->numOrbits; i++ )
		{
			printf("\t\t");
			for ( int j = 0; node->orbitSets[i][j] >= 0; j++ )
			{
				indexToPair(node->orbitSets[i][j], vi, vj);
				printf("(%d,%d) ", vi,vj);
			}
			printf("\n");
		}

//printf("-- augmenting by %d and %d \n", node->orbitReps[0], node->curOrbitCompleterReps[0]);
		working = data->augmentCompletion(indexOf(r - 2, i), 0);

		i++;
		printf("%s", data->getOneGraphString());
		printf("%s", sgtos6(data->getLayeredGraph()));
	}

	if ( !working )
	{
		printf("-- not working\n");
	}
	else
	{
		printf("%s", sgtos6(data->getZeroGraph()));
	}

	return 0;
}
